<?

function viewMe2Friends($target, $mother) {
	global $entryView;
	requireComponent("Tattertools.Function.misc");
	$me2day = getMe2Friends();

	return $target.$me2day;
}

function viewMe2FriendsSB($parameter) {
	global $configVal;
	requireComponent( "Tattertools.Function.misc");
	$data = misc::fetchConfigVal($configVal);

	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "미투 친구들의 프로필을 출력합니다.";
		return $retval;
	}

	$me2day = getMe2Friends();

	if($data['sb_use'] == 'T') {
		return $me2day;
	}return;
}

function getMe2Friends(){
	global $pluginURL, $entryView, $configVal;
	requireComponent('Eolin.PHP.HTTPRequest');
	requireComponent('Tattertools.Function.misc');
	requireComponent('Eolin.PHP.Core');
	$data = misc::fetchConfigVal($configVal);

	$me2friends_id=$data['me2friend_id']?split(',',$data['me2friend_id']):$data['me2friend_id'];
	$me2day_id=$data['me2day_id'];
	$flag = is_array($me2friends_id)?count($me2friends_id):'';
	$data['use_zoom']=$data['use_zoom']?$data['use_zoom']:'1.5';

	$me2day_url = 'http://me2day.net/'.$me2day_id;
	$me2day_rss = $me2day_url.'/friends.xml';
	$request = new HTTPRequest($me2day_rss);

	$request->timeout = 1;
	if ($request->send()){
		$rst = $request->responseText;
	}

	$xmls = new XMLStruct();
	$xmls->open($rst);

	foreach($xmls->selectNodes('/friends/friend') as $value) {
		$id = $value['.attributes']['user_id'];
		$url = $value['url'][0]['.value'];
		$homepage = $value['homepage'][0]['.value'];
		if(!ereg("^http://", $homepage) && $homepage) $homepage='http://'.$homepage;
		if(!$homepage) $homepage = 'http://me2day.net/'.$id;
		$profile_image = $value['profile_image'][0]['.value'];
		if(ereg("$id", $data['me2myfriend'])&&$data['me2myfriend'])			$icon_size=$data['icon_size']*$data['use_zoom'];
		else $icon_size=$data['icon_size'];

		if(!$flag) {
			if(ereg("$id", $data['me2myfriend'])&&$data['me2myfriend']) {
				$me2my[] = "<A href='".$homepage."' target='_blank' title='ID: $id, me2: http://me2day.net{$url}'><IMG src='".$profile_image."' width=".$icon_size." height=".$icon_size."></A> ";
			}else{
				$me2day[] = "<A href='".$homepage."' target='_blank' title='ID: $id, me2: http://me2day.net{$url}'><IMG src='".$profile_image."' width=".$icon_size." height=".$icon_size."></A> ";
			}
		}else {
			$me2friend_id = join('|', $me2friends_id);
			if(ereg("($me2friend_id)", $id)) $me2day[] = "<A href='".$homepage."' target='_blank' title='ID: $id, me2: http://me2day.net{$url}'><IMG src='".$profile_image."' width=".$icon_size." height=".$icon_size."></A> ";
		}
	}

	srand((float)microtime()*1000000);
	shuffle($me2day);
	$me2day_len = count($me2day);
	$me2my_len = count($me2my);
	$totalnum = $me2day_len+$me2my_len;
	$me2day=($data['friend_num']!=0)?array_slice($me2day, 0, $data['friend_num']-$me2my_len):$me2day;
	$me2day=array_merge($me2day, $me2my);
	shuffle($me2day);

	foreach($me2day as $k=>$v) {
		if(($k+1)%$data['friend_num_row']==0&&$data['friend_num_row']!=0) $me2day[$k]=$v."<br>";
	}

	if($data['mdf_message']) {
		$myfriend = split(',', $data['me2myfriend']);
		for($i=0; $i < count($myfriend); $i++) {
			$myfriend_msg[] = $myfriend[$i].'님';
		}
		$me2myfriend = join(', ', $myfriend_msg);
		
		$pattern = array("/\[totalnum\]/s", "/\[friendnum\]/s", "/\[iconsize\]/s", "/\[myfriend\]/s", "/\[usezoom\]/s");
		$replace = array($totalnum, $data['friend_num'], $data['icon_size'], $me2myfriend, $data['use_zoom']);
		$mdf_message = preg_replace($pattern, $replace, $data['mdf_message']);
	}

	return $data['mdf_header'].$mdf_message.join('',$me2day).$data['mdf_footer'];
}

function Me2FriendsConfig_ko($plugin) {
	global $service;
	
	$manifest = '';
	
	$manifest .= '<?xml version="1.0" encoding="utf-8"?>'.CRLF;
	$manifest .= '<config dataValHandler="">'.CRLF;
	$manifest .= '	<window width="600" height="800" />'.CRLF;
	
	$manifest .= '		<fieldset legend="미투데이 설정">'.CRLF;
	$manifest .= '		<field title="미투 주소:" name="me2day_id" type="text" value="" size="50" />';
	$manifest .= '		<field title="친구 주소:" name="me2friend_id" type="text" value="" size="50" />';
	$manifest .= '		<field title="좋은 친구:" name="me2myfriend" type="text" value="" />';
	$manifest .= '		<field title="아이콘 확대:" name="use_zoom" type="text" value="" size="3">';
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				<LI><B>미투 주소</B>: 자신의 미투데이 주소를 입력합니다. 자신의 미투데이 주소가 <A HREF="http://me2day.net/doa">http://me2day.net/doa</A>라면 <B>doa</B>만 입력하면 됩니다.<BR><LI><B>친구 주소</B>: 일종의 수동 설정 기능입니다. 친구의 미투 주소를 입력하면 여기에 등록된 친구의 프로필만 출력됩니다. 한명 이상의 친구를 입력하려면 친구 주소를 쉼표로 구분합니다. 친구 주소를 입력하지 않으면 모든 친구가 출력됩니다. 자동으로 설정하는 경우 친구의 수를 입력하면 전체 친구 중 친구의 수 만큼 랜덤하게 출력됩니다.<BR><LI><B>자동으로 설정했을 때 항상 출력할 친구의 주소를 입력</B>합니다. 한명 이상인 경우 쉼표로 구분하며, 아이콘 확대 기능을 이용해서 좋은 친구의 아이콘을 확대할 수 있다.<BR><LI><B>아이콘 확대</B>: 좋은 친구로 등록된 친구의 프로필 아이콘을 확대할 배수를 적습니다. 사이드바를 사용할 때에는 1.0으로 설정하는 것이 좋으며 기본값은 1.5입니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="전체 설정">'.CRLF;
	$manifest .= '		<field title="아이콘 크기:" name="icon_size" type="text" value="" size="2" />';
	$manifest .= '		<field title="친구의 수:" name="friend_num" type="text" value="" size="2" />';
	$manifest .= '		<field title="줄당 친구 수:" name="friend_num_row" type="text" value="" size="2">';
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				<LI><B>아이콘 크기</B>: 출력되는 친구 프로필의 아이콘 크기를 지정합니다. 지나치게 크게 지정하면 그림이 깨질 수 있습니다.<BR><LI><B>친구의 수</B>: 인기가 좋아 친구가 많은 경우 출력할 친구의 수를 지정합니다. 친구의 수를 지정하면 전체 친구 중 지정된 친구의 수만큼 랜덤하게 출력됩니다. 0으로 설정하면 모든 친구가 출력됩니다. <BR><LI><B>줄당 친구 수</B>: 한줄에 표시할 친구의 수를 지정합니다. 친구가 많거나 사이드바를 사용하는 경우 설정합다. 0으로 설정하면 모든 친구가 한줄로 출력되며 페이지 폭을 넘어가면 자동으로 줄바꿈됩니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="머릿말">'.CRLF;
	$manifest .= '		<field title="* 사용중인 skin.html 참고" name="mdf_header" cols="51" rows="2"  type="textarea" titledirection="bk" ><![CDATA[<fieldset><legend>미투친구</legend>]]></field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;
	$manifest .= '		<fieldset legend="꼬릿말">'.CRLF;
	$manifest .= '		<field title="* 사용중인 skin.html 참고" name="mdf_footer" cols="51" rows="2"  type="textarea" titledirection="bk" ><![CDATA[</fieldset>]]></field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="메시지">'.CRLF;
	$manifest .= '		<field title="* 플러그인에 출력할 메시지" name="mdf_message" cols="51" rows="2"  type="textarea" titledirection="bk"><![CDATA[* 출력되는 순서는 절대 애정도가 아닙니다. 총 <B>[totalnum]명</B>의 친구 중 <B>[friendnum]명</B>이 출력됩니다. 친구가 많아질 수록 아이콘의 크기는 줄어듭니다. 현재 아이콘의 크기는 <B>[iconsize] 픽셀</B>입니다. <BR><B>[myfriend]</B>은 좋은 친구로 등록되어 있으며, 좋은 친구로 등록된 분의 아이콘은 <B>[usezoom]배 확대</B>됩니다.<BR>]]></field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="사이드바 설정">'.CRLF;
	$manifest .= '			<field title="사이드바:" name="sb_use" type="radio">';
	$manifest .= '			<op value="T" checked="checked">사용</op>'.CRLF;
	$manifest .= '			<op value="F" >사용 안 함</op>'.CRLF;
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				사이드바를 사용할 사람은 스킨에서 치환자를 지우고 <B>사용</B>을 선택합니다. 치환자를 사용할 사람은 <B>사이드바를 사용 안 함으로 설정</B>하고 <B>치환자</B>를 스킨 파일의 원하는 위치에 삽입하면 됩니다.<BR><BR>이 플러그인에 대한 더 자세한 정보는 <A href="http://offree.net/entry/미투친구를-블로그로-태터툴즈-플러그인" target="_blank">미투친구를 블로그로, 미투친구 - 태터툴즈 플러그인</A>을 읽어보기 바랍니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;
	$manifest .= '</config>';
	
	return $manifest;
}

?>